define([
    "dojo/Deferred",
    "dojo/request"
], function(Deferred, request) {

    var authenticated = true;
    var queue = [];
    
    var _request = function(url, options) {
        var dfd = new Deferred();
        if ( authenticated ) {
            var req = request(url,options);

            // forward successfull response
            req.then(function(data){
                dfd.resolve(data);
            });
            
            req.response.then(function(response){
                // if we are recovering, launch other requests
            }, function(error) {
                if ( error.response.status === 401 ) {
                    queue.push({
                        url: url,
                        options: options,
                        dfd: dfd
                    });
                    console.log("Retry goes here :)");
                } else {
                    dfd.reject(error);
                }
            });
        } else {
            queue.push({
                url: url,
                options: options,
                dfd: dfd
            });
        }
        return dfd.promise;
    };
    return _request;
});
